/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.cvut.kbss.ejajsp;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Priklad controlleru JSP stranky
 * @author Pavel Micka
 */
@WebServlet(name = "SongServlet", urlPatterns = {"/SongServlet"})
public class SongServlet extends HttpServlet {
    private List<String> songs;

    public SongServlet() {
        //do seznamu muzeme pristupovat z vice vlaken najedou (soucasnych klientu)
        //transakce realne DB je vlaknove bezpecna z principu ACID
        this.songs = Collections.synchronizedList(new ArrayList<String>());
        
        songs.add("Let it be");
        songs.add("Yellow submarine");
        songs.add("Yesterday");
        songs.add("All you need is love");
        songs.add("Michelle");
        songs.add("Twist and shout");
        songs.add("Across the universe");
    }
    
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        request.setAttribute("songs", songs);
        request.getRequestDispatcher("/WEB-INF/songs.jsp").forward(request, response);
    }

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        String song = request.getParameter("song").trim();
        if(song != null && song.length() != 0 && !songs.contains(song)){
            songs.add(song);
        }
        
        //UPDATE-REDIRECT pattern: pokud bychom nepresmerovali, tak by uzivatel
        //po stisku F5  v prohlizeci (obnovit) odeslal znovu formular
        response.sendRedirect("SongServlet");
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Servlet showing hits by The Beatles";
    }
}
