/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.cvut.kbss.ejaservlets.support;

/**
 * Caesarova sifra
 * @author Pavel Micka
 */
public class CaesarCipher {
    /**
     * Posun (Caesarova sifra ma 3)
     */
    public static final int SHIFT = 3;

    /**
     * Zasifruje Caesarovou sifrou
     * @param s retezec obsahujici pouze velka pismena
     * @return zasifrovany retezec
     */
    public static String encipher(String s){
        StringBuilder builder = new StringBuilder();
        for(int i = 0; i < s.length(); i ++){
            if(s.charAt(i) < 65 || s.charAt(i) > 90){ //znak v ASCII
                throw new IllegalArgumentException("" +
                        "Sifrovany retezec neobsahuje jen velka pismena");
            }
            //modularne pricteme shift
            char enciphered = s.charAt(i) + SHIFT > 90 ? (char)((s.charAt(i) + SHIFT) - 26) : (char)(s.charAt(i) + SHIFT);
            builder.append(enciphered);
        }
        return builder.toString();
    }
    /**
     * Desifruje retezec zasifrovany Caesarovou sifrou
     * @param s retezec k desiforvani
     * @return desifrovany retezec
     */
    public static String decipher(String s){
        StringBuilder builder = new StringBuilder();
        for(int i = 0; i < s.length(); i ++){
            if(s.charAt(i) < 65 || s.charAt(i) > 90){ //znak v ASCII
                throw new IllegalArgumentException("" +
                        "Desifrovany retezec neobsahuje jen velka pismena");
            }
            //modularne odecteme shift
            char deciphered = s.charAt(i) - SHIFT < 65 ? (char)((s.charAt(i) - SHIFT) + 26) : (char)(s.charAt(i) - SHIFT);
            builder.append(deciphered);
        }
        return builder.toString();
    }
}